<?php
/*
Plugin Name: Quick Comment
Plugin URI: http://www.alltrees.org/Wordpress/
Description: Offers a checkbox and sends a set message, rather than a full comment; designed for use in fiction archives.
Author: Emily Ravenwood
Version: 1.4
Author URI: http://www.alltrees.org/
License: GPL v3 (http://www.gnu.org/copyleft/gpl.html)
*/

/* Add to template's archive.php and index.php:
<?php if (function_exists('quick_comment_count')) {
	quick_comment_count();
	echo ' | ';
} ?>

and comments.php:
<?php if (function_exists('quick_comment')) {
	quick_comment();
} ?>
*/

//Create the tickies table in the wordpress database
function make_tickies() {
	global $wpdb;
	
	//Set variables
	$table_name = $wpdb->prefix . "tickies";

	// If table does not already exist, create it.
	if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
	$wpdb->query("
	CREATE TABLE ".$table_name." (
	ticky_ID bigint( 20 ) unsigned NOT NULL AUTO_INCREMENT ,
	ticky_post_ID int( 11 ) NOT NULL default '0',
	ticky_author tinytext,
	ticky_author_IP varchar( 100 ) NOT NULL default '',
	ticky_date datetime NOT NULL default '0000-00-00 00:00:00',
	ticky_date_gmt datetime NOT NULL default '0000-00-00 00:00:00',
	ticky_agent varchar( 255 ) default NULL ,
	user_id bigint( 20 ) default '0',
	PRIMARY KEY ( ticky_ID )
	) 
	");

	}
}// end function


//Generate and process the quick comment form and email notification; note, function call must be placed by hand
function quick_comment() {
	
	//set all the variables we'll need
	global $wpdb;
	global $post;
	global $_POST;
	
	extract($_POST);
	extract($_REQUEST);
	extract($_SERVER);
	
	$this_file = $PHP_SELF;
	$siteroot = get_option('siteurl');
	$sitename = strtolower( $_SERVER['SERVER_NAME'] );
		if ( substr( $sitename, 0, 4 ) == 'www.' ) {
			$sitename = substr( $sitename, 4 );
		}
	
	$this_id = $post->ID;
	
	$permalink = get_permalink($post->ID);
	
	$authorid = $post->post_author;
	$author = get_userdata($authorid);
	$authormail = $author->user_email;
	
	$styling = '
		<style>
		#quick-comment { 
			border: solid 1px #000; 
			margin: 10px 0;
			padding: 3px; }
		#quick-comment h4 { 
			margin: 0; 
			padding: 6px 0; }
		#ticky-count { float: right; }
		#quick-form { padding: .5em 1em; }
		</style>
		'; //This is the css for the quick comment box; set to '' if you wish to style through your theme style sheet
		$messg_style = '
			<style>
			#quick-comment-status { border: solid 1px #000;
				padding: 1em;
				margin: 10px 0;
				text-align: center; }
			</style>
			'; //This is the css for the sent/not-sent messages; ditto above
	
	// set the table prefix, if there is one, for use in the queries
	if ($wpdb->prefix != "") {
		$prefix = $wpdb->prefix;
	}
	else {
		$prefix = "";
	}
	
	// If there are tickies to be had, fetch the number of them
	$query = "SELECT COUNT(*) FROM ".$prefix."tickies WHERE ticky_post_ID = '$this_id'";
	$r = mysql_query($query);
	$count_array = mysql_fetch_row($r);
	$count = $count_array[0];
	
	//create url for ticky form
	$action_url = $permalink ."#quick-comment-anch";
	
	//If the form has not been filled out or sent, print the form with ticky count.
	if (! $send) {
		echo '
		'.$styling.'
		 <a name="quick-comment-anch"></a>
		 <div id="quick-comment">
		<div id="ticky-count">
		Tickies sent: '.$count.'
		</div>
		<h4>Quick Comment</h4>	';
		echo "<form action=\"$action_url\" method=\"post\" id=\"quick-form\">";
		echo '
		<input type="checkbox" name="quick" id="quick" />I read this; I liked it. Ticky! <!--<br />
		Name: <input type="text" name="commenter_name" id="name" class="textarea" size="28" /> (optional)-->
		<input type="hidden" name="entry" id="story" value="'.the_title('','',FALSE).'"  />
		<input type="hidden" name="send" id="send" value="sent">
		<input type="hidden" name="ticky_post_ID" id="ticky_post_ID" value="'.$this_id.'"  />
		<input name="quickcommentbutton" type="submit" id="quickcommentbutton" value="Send quick comment" />
		</form>
		</div> 
		';
		if ($count == 1) { $readers = ' reader'; }
		else { $readers = ' readers'; }
		 if ($count != 0) {
			 echo '
			<div id="ticky-count">
			'.$count. $readers.'  sent a Quick Comment.
			</div>
			';
		} //end if not count 0 print number
	} // end if-not-submitted-yet
	
	// If form has been submitted send mail and print an acknowledgement
	else {
	  //$name =stripslashes($name);
	  
	  $commenter_name = str_replace( " ", "_", $commenter_name);
	  
	   //make the name input safe
	  $safe_name = $wpdb->escape($commenter_name);
	
	  $mailTo = $authormail; 
	  $mailSubject = "Quick Comment on \"$entry\"";
	  //If the commenter left a name, use it
	 	 if ($commenter_name) {
		 	$from = $safe_name; }
		else { //If not, mark it from Unsigned
			$from = 'Unsigned'; }
		//Construct the from-address
		$from_addr = 'archive@' . $sitename;
		
	  	$mailHeaders = "From: $from <$from_addr> \n" . "Content-Type: text/html; charset=\"" . get_option('blog_charset') . "\"\n";

	  $mailBody = '<p>'.$from.' read "'.$entry.'" and made a Quick Comment saying:</p>
	  	<p>I read this; I liked it!</p><br>
		<p><a href="'.$permalink.'">View post</a></p>';
	  
	  //If mail is successfully sent, put up the message that says so
	  if (wp_mail($mailTo,$mailSubject,$mailBody,$mailHeaders)) {
	    echo '
		'.$messg_style.'
		 <a name="quick-comment-anch"></a>
		<div id="quick-comment-status">
		Quick Comment Sent.
		</div>
		';
		
		// And insert the comment info into the tickes table
		$ticky_author = $safe_name;
		$ticky_author_IP = $REMOTE_ADDR;
		$ticky_date = date ("Y-m-d G:i:s");
		$ticky_date_gmt = gmdate ("Y-m-d G:i:s");
		$ticky_agent = $HTTP_USER_AGENT;
		$user_ID = '';
		$query = "INSERT INTO ".$prefix."tickies VALUES (NULL, '$ticky_post_ID', '$ticky_author', '$ticky_author_IP', '$ticky_date', '$ticky_date_gmt', '$ticky_agent', '$user_ID')";
		mysql_query($query);
	} //end if-form-and-mail-successful

	//If the form did not go through, print that message
	else {
	    echo '
		'.$messg_style.'
		 <a name="quick-comment-anch"></a>
		<div id="quick-comment-status">
		Quick Comment Unsuccessful. Try leaving a regular comment instead?
		</div>
		';
	}//end form-and-mail-not-successful
	
	} // end else--form submitted
	
}//end function


//Add the number of quick comments to the post metainfo section in archive view; note, function call must be placed by hand
function quick_comment_count() {
	
	//set all the variables we'll need
	global $wpdb;
	global $post;
	
	extract($_REQUEST);
	extract($_SERVER);
	
	$this_file = "http://".$_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	$this_id = $post->ID;
	$this_url = get_permalink($this_id);
	
	// set the table prefix, if there is one, for use in the query
	if ($wpdb->prefix != "") {
		$prefix = $wpdb->prefix;
	}
	else {
		$prefix = "";
	}
	
	// Fetch the number of tickes for each particular post
	$query = "SELECT COUNT(*) FROM ".$prefix."tickies WHERE ticky_post_ID = '$this_id'"; 
	$r = mysql_query($query);
	$count_array = mysql_fetch_row($r);
	$count = $count_array[0];
	
	// print it out
	echo '
	<span class="quick-tick-count"><a href="'.$this_url.'#quick-comment-anch">Quick Comments: '.$count.'</a></span>
	';
	
}//end function

register_activation_hook(__FILE__, 'make_tickies');

?>